<?php

namespace App\Console;

use App\Jobs\MonthlyTaskJob;
use Illuminate\Console\Scheduling\Schedule;
use Illuminate\Foundation\Console\Kernel as ConsoleKernel;

class Kernel extends ConsoleKernel
{
    /**
     * Define the application's command schedule.
     *
     * @param  \Illuminate\Console\Scheduling\Schedule  $schedule
     * @return void
     */
    protected function schedule(Schedule $schedule)
    {
        $schedule->job(new MonthlyTaskJob)
             ->monthlyOn(1, '00:00')
             ->timezone('Africa/Cairo');

        $schedule->command('monthly:task')
            ->monthlyOn(1, '00:00')
            ->timezone('Africa/Cairo');
        $schedule->command('daily:task')->daily();    
    }

    /**
     * Register the commands for the application.
     *
     * @return void
     */
    protected function commands()
    {
        $this->load(__DIR__.'/Commands');

        require base_path('routes/console.php');
    }
}
